#-*- mode: python; mode: fold -*-
##parameters=
# $Id: getWAeUPLayouts.py 151 2005-11-03 18:33:09Z henrik $
"""Return custom layouts types."""

##    'widgets': { ###(
##        '': {
##            'type': 'String Widget',
##            'data': {
##                'title': '',
##                'fields': ('',),
##                'is_required': False,
##                'label': '',
##                'label_edit': '',
##                'description': '',
##                'help': '',
##                'is_i18n': False,
##                'readonly_layout_modes': (),
##                'hidden_layout_modes': (),
##                'hidden_readonly_layout_modes': (),
##                'hidden_empty': False,
##                'hidden_if_expr': '',
##                'css_class': '',
##                'widget_mode_expr': '',
##                'display_width': 10,
##                'size_max': 0,
##            },

###)

Heading = { ###(
         'type': 'Heading Widget',
         'data': {
                'fields': ['heading'],
                'level': 1,
                'is_i18n': 0,
                'is_required': 1,
                'label_edit': 'Headline',
                'help': 'a short headline',
                'display_width': 40,
                'size_max': 200,
            },
        }###)

Text = { ###(
            'type': 'Text Widget',
            'data': {
                'fields': ['text'],
                'is_i18n': 1,
                'label_edit': 'Text',
                'label': 'Text',
                'help': 'a short Description',
                'css_class': 'description',
                'width': 72,
                'height': 5,
                'render_format': 'text',
                'hidden_layout_modes': (),
            },
        }###)

Title = { ###(
         'type': 'String Widget',
         'data': {
                'fields': ['Title'],
                'is_i18n': 0,
                'is_required': 1,
                'label': 'Title',
                'label_edit': 'Title',
                'display_width': 40,
                'size_max': 200,
            },
        }###)

Description = { ###(
            'type': 'Text Widget',
            'data': {
                'fields': ['Description'],
                'is_i18n': 1,
                'label_edit': 'Description',
                'label': 'Description',
                'css_class': 'description',
                'width': 72,
                'height': 5,
                'render_format': 'text',
                'hidden_layout_modes': (),
            },
        }###)

common_layout = {###(
    'widgets': {
        'LanguageSelector': {
            'type': 'Document Language Select Widget',
            'data': {
                'fields': ['Language'],
            },
        },
        'Title': Title,
        'Description': Description,
        'LanguageSelectorCreation': {
            'type': 'Select Widget',
            'data': {
                'title': 'Language',
                'fields': ('Language',),
                'is_required': 0,
                'label': 'label_language',
                'label_edit': 'label_language',
                'description': '',
                'help': '',
                'is_i18n': 0,
                'readonly_layout_modes': (),
                'hidden_layout_modes': ('create','edit', 'view'),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': 0,
                'hidden_if_expr': '',
                'css_class': '',
                'vocabulary': 'language_voc',
            },
        },
    },
    'layout': {
        'style_prefix': 'layout_waeup_',
        'rows': [
            #[{'widget_id': 'LanguageSelector'}],
            [{'widget_id': 'Title'},],
            [{'widget_id': 'Description'},],
            #[{'widget_id': 'LanguageSelectorCreation'}],
            ],
        },
    }
#
###)

student_layout = { ###(
    'widgets': {
        'jamb_is_admitted': {
            'type': 'Boolean Widget',
            'data': {
                'title': 'JAMB Admission',
                'fields': ('jamb_is_admitted',),
                'is_required': False,
                'label': 'JAMB Admission',
                'label_edit': 'JAMB Admission',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },
##        'jamb_where_admitted': {
##            'type': 'String Widget',
##            'data': {
##                'title': 'Jamb Admission Location',
##                'fields': ('jamb_where_admitted',),
##                'is_required': False,
##                'label': 'University',
##                'label_edit': 'University',
##                'description': '',
##                'help': '',
##                'is_i18n': False,
##                'readonly_layout_modes': (),
##                'hidden_layout_modes': (),
##                'hidden_readonly_layout_modes': (),
##                'hidden_empty': False,
##                'hidden_if_expr': '',
##                'css_class': '',
##                'widget_mode_expr': '',
##                'display_width': 10,
##                'size_max': 0,
##            },
##        },
        'faculty': {
            'type': 'String Widget',
            'data': {
                'title': 'Faculty',
                'fields': ('faculty',),
                'is_required': False,
                'label': 'Faculty',
                'label_edit': 'Faculty',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },
    },
    'layout': {
        'style_prefix': 'layout_default_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            #[{'widget_id': 'jamb_is_admitted', 'ncols': 1},],
            #[{'widget_id': 'jamb_where_admitted', 'ncols': 1},],
            #[{'widget_id': 'jamb_pin_usage', 'ncols': 1},],
            #[{'widget_id': 'faculty', 'ncols': 1},],
        ]
    },
}
###)

firstname = { ###(
            'type': 'String Widget',
            'data': {
                'title': 'First Name',
                'fields': ('firstname',),
                'is_required': False,
                'label': 'First Name',
                'label_edit': 'First Name',
                'description': 'First Name',
                'help': 'First name',
                'is_i18n': False,
                'display_width': 40,
                },
            }
middlename = {
            'type': 'String Widget',
            'data': {
                'title': '',
                'fields': ('middlename',),
                'is_required': False,
                'label': 'Middle Name',
                'label_edit': 'Middle Name',
                'description': '',
                'help': 'middle name',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': True,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 40,
                'size_max': 0,
                },
            }

lastname = {
            'type': 'String Widget',
            'data': {
                'title': '',
                'fields': ('lastname',),
                'is_required': False,
                'label': 'Surname',
                'label_edit': 'Surname',
                'description': '',
                'help': 'Surname',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 40,
                'size_max': 0,
            },
        }
sex = {
            'type': 'Boolean Widget',
            'data': {
                'title': '',
                'fields': ('sex',),
                'is_required': False,
                'label': 'Sex',
                'label_edit': 'Sex',
                'label_false': 'male',
                'label_true': 'female',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 20,
                'size_max': 0,
            }
        }

###)

student_personal_layout = { ###(
    'widgets': {
        'firstname': firstname,
        'middlename': middlename,
        'lastname': lastname,
        'sex': sex,
        'birthday': {
            'type': 'Date Widget',
            'data': {
                'title': '',
                'fields': ('birthday',),
                'is_required': False,
                'label': '',
                'label_edit': 'Day of birth',
                'description': 'Day of birth',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },
    },
    'layout': {
        'style_prefix': 'layout_personal_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            [{'widget_id': 'firstname', 'ncols': 1},],
            [{'widget_id': 'middlename', 'ncols': 1},],
            [{'widget_id': 'lastname', 'ncols': 1},],
            [{'widget_id': 'sex', 'ncols': 1},],
            [{'widget_id': 'birthday', 'ncols': 1},],
        ]
    },
}

###)

scratch_card = { ###(
    'widgets': {
        'sc_id': {
            'type': 'String Widget',
            'data': {
                'title': 'SC ID',
                'fields': ('sc_id',),
                'is_required': True,
                'label': 'Scratch card ID',
                'label_edit': 'Scratch card ID',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },
        'sc_pin': {
            'type': 'Scratchcard Pin Widget',
            'data': {
                'title': 'SC Pin',
                'fields': ('sc_pin'),
                'is_required': True,
                'label': 'Scratchcard Pin',
                'label_edit': 'Scratchcard Pin',
                'description': '',
                'help': 'Please enter a valid Scratch card pin',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 10,
            },
        },
    },
   'layout': {
        'style_prefix': 'layout_default_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            [{'widget_id': 'reg_nr', 'ncols': 1},],
            [{'widget_id': 'sc_pin', 'ncols': 1},],
        ]
    },
}
###)

jamb_id = { ###(
           'type': 'StudentId Widget',
           'data': {
                'title': 'Registration Number',
                'fields': ('reg_nr'),
                'is_required': True,
                'label': 'Registration Number',
                'label_edit': 'Registration Number',
                'description': '',
                'help': 'This is the combination of 8 digits and 2 letters you are assigned when you purchase an examination form.',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 10,
                 },
           }

###)

admission = { ###(
    'widgets': {
        'sc_id': {
            'type': 'String Widget',
            'data': {
                'title': 'SC ID',
                'fields': ('admission_sc_id',),
                'is_required': False,
                'label': 'Card Serial Number ',
                'label_edit': 'Card Serial Number',
                'description': 'Card Serial Number ',
                'help': 'This can be found on the bottom right of the reverse side of your Scratch Card',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': 'python:1',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },
        'sc_pin': {
            'type': 'Scratchcard Pin Widget',
            'data': {
                'title': 'SC Pin',
                'fields': ('admission_sc_pin'),
                'is_required': True,
                'label': 'PIN',
                'label_edit': 'PIN',
                'description': '',
                'help': 'PIN-(Personal Identification Number) is an 8 or 12 digit number on the reverse side of the scratch card which you can purchase from many Banks',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 10,
            },
        },
        'jamb_id' : jamb_id,
    },
   'layout': {
        'style_prefix': 'layout_admission_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            [{'widget_id': 'sc_id', 'ncols': 1},],
            [{'widget_id': 'sc_pin', 'ncols': 1},],
            [{'widget_id': 'jamb_id', 'ncols': 1},],
        ]
    },
}
###)

admission_status = { ###(
    'widgets': {
       'quick_search': {
            'type': 'String Widget',
            'data': {
                'title': 'A search string',
                'fields': ('admission_sc_id',),
                'is_required': False,
                'label': 'Quick Search',
                'label_edit': 'Quick Search',
                'description': 'Search',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': 'python:0',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 20,
                'size_max': 0,
            },
        },

    },
   'layout': {
        'style_prefix': 'layout_admission_status_',
        'flexible_widgets': (),
        'ncols': 2,
        'rows': [
            [{'widget_id': 'quick_search', 'ncols': 2},],
        ]
    },
}
###)

jamb_widgets = { ###(
        'reg_nr': {
            'type': 'StudentId Widget',
            'data': {
                'title': 'registration nr',
                'fields': ('reg_nr',),
                'is_required': True,
                'label': 'Registration Nr',
                'label_edit': 'Registration Nr',
                'description': 'The student id from JAMB',
                'help': 'The student id from JAMB',
                'is_i18n': False,
                'display_width': 10,
                'size_max': 10,
            },
        },
        'firstname': firstname,
        'middlename': middlename,
        'lastname': lastname,
        'age': {
            'type': 'Int Widget',
            'data': {
                'title': '',
                'fields': ('age',),
                'is_required': False,
                'label': 'Age',
                'label_edit': 'Age',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 2,
                'size_max': 2,
            },
        },
        'sex': sex,
        'state': {
            'type': 'Select Widget',
            'data': {
                'title': '',
                'fields': ('state',),
                'is_required': False,
                'label': 'State of Origin',
                'label_edit': 'State of Origin',
                'description': '',
                'help': '',
                'is_i18n': False,
                'vocabulary': 'nigerian_states',
            },
        },
        'exam_results': {
            'type': 'String Widget',
            'data': {
                'title': '',
                'fields': ('exam_results',),
                'is_required': False,
                'label': 'JAMB Results',
                'label_edit': 'JAMB Results',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 20,
                'size_max': 0,
            },
        },
        'aggregate': {
            'type': 'Int Widget',
            'data': {
                'title': 'Agregate',
                'fields': ('aggregate',),
                'is_required': False,
                'label': 'Score',
                'label_edit': 'Score',
                'description': '',
                'help': '',
                'is_i18n': False,
            },
        },
        'faculty': {
            'type': 'Select Widget',
            'data': {
                'title': 'Faculty',
                'fields': ('faculty',),
                'is_required': True,
                'label': 'Faculty',
                'label_edit': 'Faculty',
                'description': '',
                'help': '',
                'is_i18n': False,
                'vocabulary': 'faculties',
            },
        },
        'course': {
            'type': 'String Widget',
            'data': {
                'title': 'Study Course',
                'fields': ('course',),
                'is_required': True,
                'label': 'Study Course',
                'label_edit': 'Study Course',
                'description': '',
                'help': 'The course to study',
                'is_i18n': False,
            },
        },
        'listing_date': {
            'type': 'Date Widget',
            'data': {
                'title': 'Listing Date',
                'fields': ('listing_date',),
                'is_required': False,
                'label': 'Listing Date',
                'label_edit': 'Listing Date',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 3,
                'size_max': 0,
            },
        },
##        '2nd_choice': { ###(
##            'type': 'String Widget',
##            'data': {
##                'title': 'Second choice',
##                'fields': ('2nd_choice',),
##                'is_required': False,
##                'label': 'Second choice',
##                'label_edit': 'Second choice',
##                'description': '',
##                'help': 'second_choice',
##                'is_i18n': False,
##                'readonly_layout_modes': (),
##                'hidden_layout_modes': (),
##                'hidden_readonly_layout_modes': (),
##                'hidden_empty': False,
##                'hidden_if_expr': '',
##                'css_class': '',
##                'widget_mode_expr': '',
##                'display_width': 20,
##                'size_max': 0,
##            },
##        },
##
##        '3rd_choice': {
##            'type': 'String Widget',
##            'data': {
##                'title': 'Third_choice',
##                'fields': ('3rd_choice',),
##                'is_required': False,
##                'label': 'Third choice',
##                'label_edit': 'Third choice',
##                'description': 'third_choice',
##                'help': 'third_choice',
##                'is_i18n': False,
##                'readonly_layout_modes': (),
##                'hidden_layout_modes': (),
##                'hidden_readonly_layout_modes': (),
##                'hidden_empty': False,
##                'hidden_if_expr': '',
##                'css_class': '',
##                'widget_mode_expr': '',
##                'display_width': 20,
##                'size_max': 0,
##            },
##        },
###)

        'sc_id': {
            'type': 'String Widget',
            'data': {
                'title': '',
                'fields': ('admission_sc_id',),
                'is_required': False,
                'label': 'Scratch card ID used',
                'label_edit': 'Scratch card ID used',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 20,
                'size_max': 0,
            },
        },
        'sc_pin': {
            'type': 'String Widget',
            'data': {
                'title': '',
                'fields': ('admission_sc_pin',),
                'is_required': False,
                'label': 'Scratch Card PIN',
                'label_edit': 'Scratch Card PIN',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 20,
                'size_max': 0,
            },
        },
    }
###)

jamb_layoutcreate = { ###(
    'widgets': jamb_widgets,
    'layout': {
        'style_prefix': 'layout_jambcreate_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            [{'widget_id': 'reg_nr', 'ncols': 1},],
            [{'widget_id': 'firstname', 'ncols': 1},],
            [{'widget_id': 'middlename', 'ncols': 1},],
            [{'widget_id': 'lastname', 'ncols': 1},],
            #[{'widget_id': 'sc_id', 'ncols': 1},],
            #[{'widget_id': 'sc_pin', 'ncols': 1},],
            [{'widget_id': 'age', 'ncols': 1},],
            [{'widget_id': 'sex', 'ncols': 1},],
            [{'widget_id': 'state', 'ncols': 1},],
            #[{'widget_id': 'exam_results', 'ncols': 1},],
            [{'widget_id': 'aggregate', 'ncols': 1},],
            [{'widget_id': 'faculty', 'ncols': 1},],
            [{'widget_id': 'course', 'ncols': 1},],
            [{'widget_id': 'listing_date', 'ncols': 1},],
            #[{'widget_id': '2nd_choice', 'ncols': 1},],
            #[{'widget_id': '3rd_choice', 'ncols': 1},],
        ]
    },
}
###)

jamb_layout = { ###(
    'widgets': jamb_widgets,
    'layout': {
        'style_prefix': 'layout_waeup_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            [{'widget_id': 'reg_nr', 'ncols': 1},],
            [{'widget_id': 'firstname', 'ncols': 1},],
            [{'widget_id': 'middlename', 'ncols': 1},],
            [{'widget_id': 'lastname', 'ncols': 1},],
            #[{'widget_id': 'sc_id', 'ncols': 1},],
            [{'widget_id': 'sc_pin', 'ncols': 1},],
            [{'widget_id': 'age', 'ncols': 1},],
            [{'widget_id': 'sex', 'ncols': 1},],
            [{'widget_id': 'state', 'ncols': 1},],
            #[{'widget_id': 'exam_results', 'ncols': 1},],
            [{'widget_id': 'aggregate', 'ncols': 1},],
            [{'widget_id': 'faculty', 'ncols': 1},],
            [{'widget_id': 'course', 'ncols': 1},],
            [{'widget_id': 'listing_date', 'ncols': 1},],
            #[{'widget_id': '2nd_choice', 'ncols': 1},],
            #[{'widget_id': '3rd_choice', 'ncols': 1},],
        ]
    },
}
###)

course = { ###(
    'widgets': {
        'heading': {
         'type': 'String Widget',
         'data': {
                'fields': ['heading'],
                'is_i18n': 0,
                'is_required': 1,
                'label': 'Title',
                'label_edit': 'Title',
                'help': 'Course Title',
                'display_width': 40,
                'size_max': 40,
            },
        },
        'text': Text,
        'level': {
            'type': 'Select Widget',
            'data': {
                'title': '',
                'fields': ('level',),
                'is_required': True,
                'label': 'Level',
                'label_edit': 'Level',
                'description': '',
                'help': '',
                'is_i18n': False,
                'vocabulary': 'courselevel',
            },
        },
        'code': {
            'type': 'String Widget',
            'data': {
                'title': 'Code',
                'fields': ('code',),
                'is_required': True,
                'label': 'Code',
                'label_edit': 'Code',
                'description': '',
                'help': '',
                'is_i18n': False,
                'display_width': 10,
                'size_max': 0,
            },
        },
        'semester': {
            'type': 'Boolean Widget',
            'data': {
                'title': '',
                'fields': ('semester',),
                'is_required': True,
                'label': 'Semester',
                'label_edit': 'Semester',
                'label_false': 'Second Semester',
                'label_true': 'First Semester',
                'description': '',
                'help': '',
                'is_i18n': False,
                'display_width': 10,
                'size_max': 0,
            },
        },
        'credit': {
            'type': 'Int Widget',
            'data': {
                'title': '',
                'fields': ('credit',),
                'is_required': True,
                'label': 'Credit',
                'label_edit': 'Credit',
                'description': '',
                'help': '',
                'is_i18n': False,
                'display_width': 2,
                'size_max': 0,
            },
        },
        'core_elective': {
            'type': 'Boolean Widget',
            'data': {
                'title': '',
                'fields': ('core_elective',),
                'is_required': True,
                'label': 'Core or elective',
                'label_edit': 'Core or elective',
                'label_true': 'Core Course',
                'label_false': 'Elective Course',
                'description': '',
                'help': '',
                'is_i18n': False,
                'display_width': 10,
                'size_max': 0,
            },
        },
    },
   'layout': {
        'style_prefix': 'layout_waeup_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            [{'widget_id': 'heading', 'ncols': 1},],
            #[{'widget_id': 'Title', 'ncols': 1},],
            [{'widget_id': 'text', 'ncols': 1},],
            [{'widget_id': 'level', 'ncols': 1},],
            [{'widget_id': 'code', 'ncols': 1},],
            [{'widget_id': 'semester', 'ncols': 1},],
            [{'widget_id': 'credit', 'ncols': 1},],
            [{'widget_id': 'core_elective', 'ncols': 1},],
        ]
    },
}
###)

course_results = { ###(
    'widgets': {
        'points': {
            'type': 'Int Widget',
            'data': {
                'title': '',
                'fields': ('points',),
                'is_required': False,
                'label': 'Points',
                'label_edit': 'Points',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 3,
                'size_max': 3,
            },
        },
        'grade': {
            'type': 'String Widget',
            'data': {
                'title': '',
                'fields': ('grade'),
                'is_required': False,
                'label': 'Grade',
                'label_edit': 'Grade',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 2,
                'size_max': 1,
            },
        },
    },
   'layout': {
        'style_prefix': 'layout_default_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            [{'widget_id': 'points', 'ncols': 1},],
            [{'widget_id': 'grade', 'ncols': 1},],
        ]
    },
}
###)

study_level = { ###(
    'widgets': {
        'Title': {
            'type': 'Select Widget',
            'data': {
                'title': '',
                'fields': ('Title',),
                'is_required': False,
                'label': 'Study Level',
                'label_edit': 'Study Level',
                'description': '',
                'help': '',
                'vocabulary': 'courselevel',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 20,
                'size_max': 0,
            },
        },
    },
   'layout': {
        'style_prefix': 'layout_waeup_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            [{'widget_id': 'Title', 'ncols': 1},],
        ]
    },
}
###)

accommodation = { ###(
    'widgets': {
        'heading': {
         'type': 'String Widget',
         'data': {
                'fields': ['heading'],
                'level': 2,
                'is_i18n': 0,
                'is_required': 1,
                'label': 'Hall Name',
                'label_edit': 'Hall Name',
                'help': '',
                'display_width': 40,
                'size_max': 40,
            },
        },
        'text': Text,
        'which_sex': {
            'type': 'Boolean Widget',
            'data': {
                'title': '',
                'fields': ('which_sex',),
                'is_required': False,
                'label': 'Sex',
                'label_edit': 'Sex',
                'label_false': 'male',
                'label_true': 'female',
                'description': '',
                'help': '',
                'is_i18n': False,
            },
        },
        'nr_of_blocks': {
            'type': 'Select Widget',
            'data': {
                'title': '',
                'fields': ('nr_of_blocks',),
                'is_required': True,
                'label': 'Nr of Blocks',
                'label_edit': 'Nr of Blocks',
                'description': '',
                'help': 'Number of blocks',
                'is_i18n': False,
                'vocabulary': 'range10',
            },
        },
        'nr_of_floors': {
            'type': 'Select Widget',
            'data': {
                'title': '',
                'fields': ('nr_of_floors',),
                'is_required': True,
                'label': 'Nr of Floors ',
                'label_edit': 'Nr of Floors',
                'description': '',
                'help': 'Number of floors per block',
                'is_i18n': False,
                'vocabulary': 'range5',
            },
        },
        'rooms_per_floor': {
            'type': 'Select Widget',
            'data': {
                'title': '',
                'fields': ('rooms_per_floor',),
                'is_required': True,
                'label': 'Rooms per Floor',
                'label_edit': 'Rooms per Floor',
                'description': '',
                'help': 'Number of rooms per floor',
                'is_i18n': False,
                'vocabulary': 'range50',
            },
        },
        'beds_per_room': {
            'type': 'Select Widget',
            'data': {
                'title': '',
                'fields': ('beds_per_room',),
                'is_required': True,
                'label': 'Beds per Room',
                'label_edit': 'Beds per Room',
                'description': '',
                'help': 'Number of beds per room',
                'is_i18n': False,
                'vocabulary': 'range10',
            },
        },
        'beds_assigned': {
            'type': 'Int Widget',
            'data': {
                'title': '',
                'fields': ('beds_assigned',),
                'is_required': True,
                'label': 'Assigned Beds',
                'label_edit': 'Assigned Beds',
                'description': '',
                'help': 'Number of beds already assined to students',
                'is_i18n': False,
            },
        },
    },
   'layout': {
        'style_prefix': 'layout_waeup_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            [{'widget_id': 'heading', 'ncols': 1},],
            #[{'widget_id': 'Title', 'ncols': 1},],
            [{'widget_id': 'text', 'ncols': 1},],
            [{'widget_id': 'which_sex', 'ncols': 1},],
            [{'widget_id': 'nr_of_blocks', 'ncols': 1},],
            [{'widget_id': 'nr_of_floors', 'ncols': 1},],
            [{'widget_id': 'rooms_per_floor', 'ncols': 1},],
            [{'widget_id': 'beds_per_room', 'ncols': 1},],
            [{'widget_id': 'beds_assigned', 'ncols': 1},],
        ]
    },
}
###)

accobook = { ###(
    'widgets': {
        'sc_id': {
            'type': 'String Widget',
            'data': {
                'title': 'SC ID',
                'fields': ('accommodation_sc_id',),
                'is_required': False,
                'label': 'Card Serial Number ',
                'label_edit': 'Card Serial Number',
                'description': 'Card Serial Number ',
                'help': 'This can be found on the bottom right of the reverse side of your Scratch Card',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': 'python:1',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },
        'sc_pin': {
            'type': 'Scratchcard Pin Widget',
            'data': {
                'title': 'SC Pin',
                'fields': ('accommodation_sc_pin'),
                'is_required': True,
                'label': 'enter an Accommodation PIN',
                'label_edit': 'enter an Accommodation PIN',
                'description': '',
                'help': 'Please enter a PIN valid for Accomodation booking',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 10,
            },
        },
    },
   'layout': {
        'style_prefix': 'layout_accobook_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            #[{'widget_id': 'sc_id', 'ncols': 1},],
            [{'widget_id': 'sc_pin', 'ncols': 1},],
        ]
    },
}
###)

layouts = {}
layouts['university'] = common_layout
layouts['waeup_common'] = common_layout
layouts['student'] = student_layout
layouts['study_level'] = study_level
layouts['student_personal'] = student_personal_layout
layouts['accommodation'] = accommodation
layouts['accobook'] = accobook
layouts['scratch_card'] = scratch_card
layouts['admission'] = admission
layouts['jambcreate'] = jamb_layoutcreate
layouts['jamb'] = jamb_layout
layouts['faculty'] = common_layout
layouts['department'] = common_layout
layouts['course'] = course
layouts['admission_status'] = admission_status
return layouts
